//Example 1-3
//Simple Drawing Program - by George Hadjikyriacou
//License: GPL v3 (http://www.gnu.org/licenses/gpl.html)

int x=0, y=0, x1=0, y1=0, x2=0, y2=0;
String create_shape="rect", str_color="blue";
color pick_color = color(0,0,255);
PFont font;
boolean fill_it=false;
PImage stamp;

void setup() {
  size(600, 400, JAVA2D);
  colorMode(RGB, 255);
  background(255,255,255);
  fill(0,0,255);
  font = loadFont("DejaVuSans-14.vlw"); 
  textFont(font);
  rectMode(CORNERS);
  ellipseMode(CORNERS);
  imageMode(CENTER);
}

void draw() {
  fill(255,255,255);
  noStroke();
  rect(0,0,380,25);
  fill(0,0,0);
  text("Shape:", 10, 20);
  fill(0,0,255);
  text(create_shape, 60, 20);
  fill(0,0,0);
  text("Color:", 120, 20);
  fill(0,0,255);
  text(str_color, 160, 20);
  fill(0,0,0);
  text("X:", 210, 20);
  fill(0,0,255);
  text(x, 230, 20);
  fill(0,0,0);
  text("Y:", 270, 20);
  fill(0,0,255);
  text(y, 290, 20);
  fill(0,0,0);
  text("Fill:", 330, 20);
  fill(0,0,255);
  text(int(fill_it), 360, 20);  
  noLoop();
}

void mouseDragged() {
  x=mouseX;
  y=mouseY;
  loop();
}

void mousePressed() {
  x=mouseX;
  y=mouseY;
  x1=mouseX;
  y1=mouseY;
  loop();
}

void mouseReleased() {

  x2=mouseX;
  y2=mouseY;
  if(fill_it) {
    fill(pick_color);
  }
  else {
    noFill();
  }
  stroke(pick_color);
  if(create_shape=="rect") {
    rect(x1, y1, x2, y2);
  }
  if(create_shape=="ellipse") {
    ellipse(x1, y1, x2, y2);
  }
  if(create_shape=="line") {
    stroke(pick_color);
    line(x1, y1, x2, y2);
  }
  if(create_shape=="stamp") {
    image(stamp, x, y);
  }
  loop();
}

void keyPressed() {
  if (key == '1') {
    create_shape = "ellipse";
  }
  if (key == '2') {
    create_shape = "rect";
  }    
  if (key == '3') {
    create_shape = "line";
  }
  if (key == '4') {
    stamp = loadImage("processing.png");
    create_shape = "stamp";
  }
  if (key == '5') {
    fill_it = true;
  }
  if (key == '6') {
    fill_it = false;
  }

  if (key == 'r') {
    pick_color = color(255,0,0);
    str_color = "red";
  }
  if (key == 'g') {
    pick_color = color(0,255,0);
    str_color = "green";
  }  
  if (key == 'b') {
    pick_color = color(0,0,255);
    str_color = "blue";
  }  
  if (key == 'y') {
    pick_color = color(255,255,0);
    str_color = "yellow";
  } 
  if (key == 'w') {
    pick_color = color(255,255,255);
    str_color = "white";
  } 
  if (key == 'n') {
    pick_color = color(0,0,0);
    str_color = "black";
  } 
  if (key == 's') {
    save("data/image.jpg");
  }
  if (key == 'l') {
    PImage load_image = loadImage("data/image.jpg");
    image(load_image, 0, 0);
  }
  loop();
}

